Multiple Colors in JavaScript

Using ApexCharts with JavaScript

This Multiple Colors example uses ApexCharts.js directly in JavaScript, with no wrapper component.

Install it with npm install apexcharts, then mount the chart with new ApexCharts(element, options).render().

JavaScript installation guide
// Seeded PRNG so the heatmap is identical on every load (stable snapshots).
var __seed = 0x77081a3b
function rand() {
  __seed |= 0
  __seed = (__seed + 0x6d2b79f5) | 0
  var t = Math.imul(__seed ^ (__seed >>> 15), 1 | __seed)
  t = (t + Math.imul(t ^ (t >>> 7), 61 | t)) ^ t
  return ((t ^ (t >>> 14)) >>> 0) / 4294967296
}

function generateData(count, yrange) {
  var i = 0
  var series = []
  while (i < count) {
    var x = (i + 1).toString()
    var y = Math.floor(rand() * (yrange.max - yrange.min + 1)) + yrange.min

    series.push({
      x: x,
      y: y,
    })
    i++
  }
  return series
}

var data = [
  {
    name: 'W1',
    data: generateData(8, {
      min: 0,
      max: 90,
    }),
  },
  {
    name: 'W2',
    data: generateData(8, {
      min: 0,
      max: 90,
    }),
  },
  {
    name: 'W3',
    data: generateData(8, {
      min: 0,
      max: 90,
    }),
  },
  {
    name: 'W4',
    data: generateData(8, {
      min: 0,
      max: 90,
    }),
  },
  {
    name: 'W5',
    data: generateData(8, {
      min: 0,
      max: 90,
    }),
  },
  {
    name: 'W6',
    data: generateData(8, {
      min: 0,
      max: 90,
    }),
  },
  {
    name: 'W7',
    data: generateData(8, {
      min: 0,
      max: 90,
    }),
  },
  {
    name: 'W8',
    data: generateData(8, {
      min: 0,
      max: 90,
    }),
  },
  {
    name: 'W9',
    data: generateData(8, {
      min: 0,
      max: 90,
    }),
  },
  {
    name: 'W10',
    data: generateData(8, {
      min: 0,
      max: 90,
    }),
  },
  {
    name: 'W11',
    data: generateData(8, {
      min: 0,
      max: 90,
    }),
  },
  {
    name: 'W12',
    data: generateData(8, {
      min: 0,
      max: 90,
    }),
  },
  {
    name: 'W13',
    data: generateData(8, {
      min: 0,
      max: 90,
    }),
  },
  {
    name: 'W14',
    data: generateData(8, {
      min: 0,
      max: 90,
    }),
  },
  {
    name: 'W15',
    data: generateData(8, {
      min: 0,
      max: 90,
    }),
  },
]

data.reverse()

var colors = [
  '#F3B415',
  '#F27036',
  '#663F59',
  '#6A6E94',
  '#4E88B4',
  '#00A7C6',
  '#18D8D8',
  '#A9D794',
  '#46AF78',
  '#A93F55',
  '#8C5E58',
  '#2176FF',
  '#33A1FD',
  '#7A918D',
  '#BAFF29',
]

colors.reverse()

var options = {
  series: data,
  chart: {
    height: 450,
    type: 'heatmap',
  },
  dataLabels: {
    enabled: false,
  },
  colors: colors,
  xaxis: {
    type: 'category',
    categories: [
      '10:00',
      '10:30',
      '11:00',
      '11:30',
      '12:00',
      '12:30',
      '13:00',
      '13:30',
    ],
  },
  title: {
    text: 'Room Occupancy by Week & Time (per-row colors)',
  },
  grid: {
    padding: {
      right: 20,
    },
  },
}

var chart = new ApexCharts(document.querySelector('#chart'), options)
chart.render()

Multiple Colors in Vue

Using ApexCharts with Vue

This Multiple Colors example wires ApexCharts into Vue through the vue3-apexcharts component.

Install it with npm install vue3-apexcharts apexcharts, then mount the chart with <apexchart type="..." :options="options" :series="series" />.

Vue charts guide
<template>
  <div>
    <div id="chart">
      <apexchart
        type="heatmap"
        height="450"
        :options="chartOptions"
        :series="series"
      ></apexchart>
    </div>
  </div>
</template>

<script>
import VueApexCharts from 'vue-apexcharts'

// Seeded PRNG so the heatmap is identical on every load (stable snapshots).
var __seed = 0x77081a3b
function rand() {
  __seed |= 0
  __seed = (__seed + 0x6d2b79f5) | 0
  var t = Math.imul(__seed ^ (__seed >>> 15), 1 | __seed)
  t = (t + Math.imul(t ^ (t >>> 7), 61 | t)) ^ t
  return ((t ^ (t >>> 14)) >>> 0) / 4294967296
}

function generateData(count, yrange) {
  var i = 0
  var series = []
  while (i < count) {
    var x = (i + 1).toString()
    var y = Math.floor(rand() * (yrange.max - yrange.min + 1)) + yrange.min

    series.push({
      x: x,
      y: y,
    })
    i++
  }
  return series
}

var data = [
  {
    name: 'W1',
    data: generateData(8, {
      min: 0,
      max: 90,
    }),
  },
  {
    name: 'W2',
    data: generateData(8, {
      min: 0,
      max: 90,
    }),
  },
  {
    name: 'W3',
    data: generateData(8, {
      min: 0,
      max: 90,
    }),
  },
  {
    name: 'W4',
    data: generateData(8, {
      min: 0,
      max: 90,
    }),
  },
  {
    name: 'W5',
    data: generateData(8, {
      min: 0,
      max: 90,
    }),
  },
  {
    name: 'W6',
    data: generateData(8, {
      min: 0,
      max: 90,
    }),
  },
  {
    name: 'W7',
    data: generateData(8, {
      min: 0,
      max: 90,
    }),
  },
  {
    name: 'W8',
    data: generateData(8, {
      min: 0,
      max: 90,
    }),
  },
  {
    name: 'W9',
    data: generateData(8, {
      min: 0,
      max: 90,
    }),
  },
  {
    name: 'W10',
    data: generateData(8, {
      min: 0,
      max: 90,
    }),
  },
  {
    name: 'W11',
    data: generateData(8, {
      min: 0,
      max: 90,
    }),
  },
  {
    name: 'W12',
    data: generateData(8, {
      min: 0,
      max: 90,
    }),
  },
  {
    name: 'W13',
    data: generateData(8, {
      min: 0,
      max: 90,
    }),
  },
  {
    name: 'W14',
    data: generateData(8, {
      min: 0,
      max: 90,
    }),
  },
  {
    name: 'W15',
    data: generateData(8, {
      min: 0,
      max: 90,
    }),
  },
]

data.reverse()

var colors = [
  '#F3B415',
  '#F27036',
  '#663F59',
  '#6A6E94',
  '#4E88B4',
  '#00A7C6',
  '#18D8D8',
  '#A9D794',
  '#46AF78',
  '#A93F55',
  '#8C5E58',
  '#2176FF',
  '#33A1FD',
  '#7A918D',
  '#BAFF29',
]

colors.reverse()

export default {
  components: {
    apexchart: VueApexCharts,
  },
  data: function () {
    return {
      series: data,
      chartOptions: {
        chart: {
          height: 450,
          type: 'heatmap',
        },
        dataLabels: {
          enabled: false,
        },
        colors: colors,
        xaxis: {
          type: 'category',
          categories: [
            '10:00',
            '10:30',
            '11:00',
            '11:30',
            '12:00',
            '12:30',
            '13:00',
            '13:30',
          ],
        },
        title: {
          text: 'Room Occupancy by Week & Time (per-row colors)',
        },
        grid: {
          padding: {
            right: 20,
          },
        },
      },
    }
  },
}
</script>

<style>
#chart {
  max-width: 650px;
  margin: 35px auto;
}
</style>

Multiple Colors in Angular

Using ApexCharts with Angular

This Multiple Colors example wires ApexCharts into Angular through the ng-apexcharts component.

Install it with npm install ng-apexcharts apexcharts, then mount the chart with <apx-chart [series]="series" [chart]="chart"></apx-chart>.

Angular charts guide

This demo uses imperative chart updates. The generated code is a faithful Angular translation: open it in CodeSandbox to run and tweak.

import { Component, AfterViewInit, OnDestroy, ViewChild } from '@angular/core';
import {
  ChartComponent,
  ApexAxisChartSeries,
  ApexNonAxisChartSeries,
  ApexChart,
  ApexXAxis,
  ApexYAxis,
  ApexTitleSubtitle,
  ApexDataLabels,
  ApexStroke,
  ApexFill,
  ApexLegend,
  ApexTooltip,
  ApexMarkers,
  ApexPlotOptions,
  ApexResponsive,
  ApexGrid,
  ApexAnnotations,
  ApexStates,
  ApexTheme,
  NgApexchartsModule,
} from 'ng-apexcharts';

export type ChartOptions = {
  series?: ApexAxisChartSeries | ApexNonAxisChartSeries;
  chart?: ApexChart;
  xaxis?: ApexXAxis;
  yaxis?: ApexYAxis | ApexYAxis[];
  title?: ApexTitleSubtitle;
  subtitle?: ApexTitleSubtitle;
  dataLabels?: ApexDataLabels;
  stroke?: ApexStroke;
  fill?: ApexFill;
  legend?: ApexLegend;
  tooltip?: ApexTooltip;
  markers?: ApexMarkers;
  plotOptions?: ApexPlotOptions;
  responsive?: ApexResponsive[];
  grid?: ApexGrid;
  annotations?: ApexAnnotations;
  states?: ApexStates;
  theme?: ApexTheme;
  colors?: string[];
  labels?: any;
};

@Component({
  selector: 'app-chart',
  standalone: true,
  imports: [NgApexchartsModule],
  templateUrl: './chart.component.html',
})
export class AppChart implements AfterViewInit, OnDestroy {
  @ViewChild('chart') chart!: ChartComponent;
  public chartOptions: Partial<ChartOptions> = {
          series: data,
          chart: {
            height: 450,
            type: 'heatmap',
          },
          dataLabels: {
            enabled: false,
          },
          colors: colors,
          xaxis: {
            type: 'category',
            categories: [
              '10:00',
              '10:30',
              '11:00',
              '11:30',
              '12:00',
              '12:30',
              '13:00',
              '13:30',
            ],
          },
          title: {
            text: 'Room Occupancy by Week & Time (per-row colors)',
          },
          grid: {
            padding: {
              right: 20,
            },
          },
        };
  ngAfterViewInit() {
    (window as any).ApexCharts.setLicense('APEX-eyJleHBpcnlEYXRlIjoiMjEyNi0wNy0wNCIsImlzc3VlRGF0ZSI6IjIwMjYtMDctMjgiLCJwbGFuIjoicHJlbWl1bSIsImRvbWFpbnMiOlsiYXBleGNoYXJ0cy5jb20iLCIxMjcuMC4wLjEiLCJsb2NhbGhvc3QiXSwic2lnIjoieVBmb1VCc0Z3TU9ZdUEyaEZkR0I2Y1FtZ0JITUtXcVdJSjB2NVRESXRZbFR3eDJMUmh6R2x0RUc3VXJ4X0s3b25ZMWRZb2Z2VGItN01ydFYyNDVyOWcifQ==');
  }

  ngOnDestroy() {
    // no cleanup needed
  }
}

Multiple Colors in React

Using ApexCharts with React

This Multiple Colors example wires ApexCharts into React through the react-apexcharts component.

Install it with npm install react-apexcharts apexcharts, then mount the chart with <Chart type="..." options={options} series={series} />.

React charts guide
import React from 'react'
import ReactApexChart from 'react-apexcharts'
import './styles.css'

// Seeded PRNG so the heatmap is identical on every load (stable snapshots).
var __seed = 0x77081a3b
function rand() {
  __seed |= 0
  __seed = (__seed + 0x6d2b79f5) | 0
  var t = Math.imul(__seed ^ (__seed >>> 15), 1 | __seed)
  t = (t + Math.imul(t ^ (t >>> 7), 61 | t)) ^ t
  return ((t ^ (t >>> 14)) >>> 0) / 4294967296
}

function generateData(count, yrange) {
  var i = 0
  var series = []
  while (i < count) {
    var x = (i + 1).toString()
    var y = Math.floor(rand() * (yrange.max - yrange.min + 1)) + yrange.min

    series.push({
      x: x,
      y: y,
    })
    i++
  }
  return series
}

var data = [
  {
    name: 'W1',
    data: generateData(8, {
      min: 0,
      max: 90,
    }),
  },
  {
    name: 'W2',
    data: generateData(8, {
      min: 0,
      max: 90,
    }),
  },
  {
    name: 'W3',
    data: generateData(8, {
      min: 0,
      max: 90,
    }),
  },
  {
    name: 'W4',
    data: generateData(8, {
      min: 0,
      max: 90,
    }),
  },
  {
    name: 'W5',
    data: generateData(8, {
      min: 0,
      max: 90,
    }),
  },
  {
    name: 'W6',
    data: generateData(8, {
      min: 0,
      max: 90,
    }),
  },
  {
    name: 'W7',
    data: generateData(8, {
      min: 0,
      max: 90,
    }),
  },
  {
    name: 'W8',
    data: generateData(8, {
      min: 0,
      max: 90,
    }),
  },
  {
    name: 'W9',
    data: generateData(8, {
      min: 0,
      max: 90,
    }),
  },
  {
    name: 'W10',
    data: generateData(8, {
      min: 0,
      max: 90,
    }),
  },
  {
    name: 'W11',
    data: generateData(8, {
      min: 0,
      max: 90,
    }),
  },
  {
    name: 'W12',
    data: generateData(8, {
      min: 0,
      max: 90,
    }),
  },
  {
    name: 'W13',
    data: generateData(8, {
      min: 0,
      max: 90,
    }),
  },
  {
    name: 'W14',
    data: generateData(8, {
      min: 0,
      max: 90,
    }),
  },
  {
    name: 'W15',
    data: generateData(8, {
      min: 0,
      max: 90,
    }),
  },
]

data.reverse()

var colors = [
  '#F3B415',
  '#F27036',
  '#663F59',
  '#6A6E94',
  '#4E88B4',
  '#00A7C6',
  '#18D8D8',
  '#A9D794',
  '#46AF78',
  '#A93F55',
  '#8C5E58',
  '#2176FF',
  '#33A1FD',
  '#7A918D',
  '#BAFF29',
]

colors.reverse()

const ApexChart = () => {
  const [state, setState] = React.useState({
    series: data,
    options: {
      chart: {
        height: 450,
        type: 'heatmap',
      },
      dataLabels: {
        enabled: false,
      },
      colors: colors,
      xaxis: {
        type: 'category',
        categories: [
          '10:00',
          '10:30',
          '11:00',
          '11:30',
          '12:00',
          '12:30',
          '13:00',
          '13:30',
        ],
      },
      title: {
        text: 'Room Occupancy by Week & Time (per-row colors)',
      },
      grid: {
        padding: {
          right: 20,
        },
      },
    },
  })

  return (
    <div>
      <div id="chart">
        <ReactApexChart
          options={state.options}
          series={state.series}
          type="heatmap"
          height={450}
        />
      </div>
    </div>
  )
}

export default ApexChart